
package smm.mpsspackage;

import android.content.Intent;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.Rect;
import android.graphics.Point;
import android.graphics.PixelFormat;
import android.media.Image;

import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.IOnActivityResult;

import android.media.projection.MediaProjectionManager;
import android.media.projection.MediaProjection;
import android.hardware.display.VirtualDisplay;
import android.hardware.display.DisplayManager;
import android.util.DisplayMetrics;
import android.view.WindowManager;
import android.view.Display;
import android.media.ImageReader;
import android.os.Handler;
import java.nio.ByteBuffer;
import java.util.concurrent.Callable;

@Version(2.0000000000000013f)
@ShortName("MediaProjectionScreenShot")
@Author("SMM")

public class mpss
	{
		private BA ba;	
		private MediaProjectionManager mProjectionManager;
		private MediaProjection mProjection;
		private String eventName;
		private IOnActivityResult ion;
		private Intent ResultIntent;
		
		public int PermissionGranted = 1;
		public boolean mProjectionRunning = false;
		
		public void Initialize(BA ba, String EventName)
		{
			this.ba = ba;
			this.eventName = EventName.toLowerCase(BA.cul);
			mProjectionManager = (MediaProjectionManager) ba.applicationContext.getSystemService(Context.MEDIA_PROJECTION_SERVICE);
		}

		//@ActivityObject
		public void AskforPermission(final BA b)
		{
			{
			ion = new IOnActivityResult()
			{
				@Override
				public void ResultArrived(int arg0, Intent data)
				{
					PermissionGranted = arg0;
					if (PermissionGranted==-1)
					{
						ResultIntent = data;
						if (b.subExists(eventName + "_permissiongranted"))
						{
							b.raiseEvent2(b, false, eventName + "_permissiongranted", true, new Object[0]);
						}
					}		 
				}
			};
			b.startActivityForResult(ion, mProjectionManager.createScreenCaptureIntent());
			}
		}
		
		Handler handler = new Handler();
		DisplayMetrics metrics;
		ImageReader mImageReader;

		public void Stop()
		{
			if (mProjectionRunning == true)
			{
				mProjection.stop();
				mProjectionRunning = false;
			}
		}

		public void init(int width , int height , int density)
		{
			if (PermissionGranted==-1)
			{
				if (mProjectionRunning == false)
				{
					mProjection = mProjectionManager.getMediaProjection(-1, ResultIntent); 
					mProjectionRunning = true;
				}
	
				WindowManager wm = (WindowManager) ba.context.getSystemService(Context.WINDOW_SERVICE);
				Display display = wm.getDefaultDisplay();
				metrics = new DisplayMetrics();
				display.getRealMetrics(metrics);
				Point size = new Point();
				display.getRealSize(size);
				int mWidth = 0;
				int mHeight = 0;
				int mDensity = 0;
				if (width > 0) {mWidth = width;} else {mWidth = size.x;}
				if (height > 0) {mHeight = height;} else {mHeight = size.y;}	
				if (density > 0) {mDensity = density;} else {mDensity = metrics.densityDpi;} 
				mImageReader = ImageReader.newInstance(mWidth, mHeight, PixelFormat.RGBA_8888, 2);
				int flags = DisplayManager.VIRTUAL_DISPLAY_FLAG_OWN_CONTENT_ONLY | DisplayManager.VIRTUAL_DISPLAY_FLAG_PUBLIC ;
				mProjection.createVirtualDisplay("screen-mirror", mWidth, mHeight, mDensity, flags, mImageReader.getSurface(), null, handler);
			}		 
		}

		public void TakeScreenshot(final boolean StopAfterTaken)
		{
			ba.runAsync(ba, this, "",  null, new Callable<Object[]>()
			{
				@Override
				public Void[] call() throws Exception
				{
					mImageReader.setOnImageAvailableListener(new ImageReader.OnImageAvailableListener()
					{
						@Override
						public void onImageAvailable(ImageReader reader)
						{
							reader.setOnImageAvailableListener(null, handler);
							Image image = reader.acquireLatestImage();
							final Image.Plane[] planes = image.getPlanes();
							final ByteBuffer buffer = planes[0].getBuffer();

							int pixelStride = planes[0].getPixelStride();
							int rowStride = planes[0].getRowStride();
							int rowPadding = rowStride - pixelStride * metrics.widthPixels;

							Bitmap bmp = Bitmap.createBitmap(metrics.widthPixels + (int)((float) rowPadding / (float) pixelStride), metrics.heightPixels, Bitmap.Config.ARGB_8888);
							bmp.copyPixelsFromBuffer(buffer);
							Rect rect = image.getCropRect();

							if (ba.subExists(eventName + "_imageready"))
							{
								ba.raiseEvent2(ba, false, eventName + "_imageready", true, new Object[]{Bitmap.createBitmap(bmp, 0, 0, image.getWidth(), image.getHeight())});
								if (StopAfterTaken == true) {Stop();}
							}
							image.close();
							reader.close();
							bmp.recycle();
						}
					}, handler);
					return null;
				}
			});
		}
	}

